SystemOrganization addCategory: #'PolySource-Core'!
SystemOrganization addCategory: #'PolySource-Tests'!

ProtoObject subclass: #PSSystemDictionaryProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionaryProxy class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:42:02.667'!
install

	self new install.! !

!PSSystemDictionaryProxy class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:42:35.209'!
uninstall

	Smalltalk globals uninstall.! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:48:24.671'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentSystemDictionary value ifNil: [original])! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:14:34.987'!
install

	self isInstalled ifTrue: [^self].

	original := Smalltalk globals.
	Smalltalk instVarNamed: #globals put: self.
! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:14:19.08'!
isInstalled

	^ Smalltalk globals == self! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:18:46.109'!
uninstall

	self isInstalled ifFalse: [^self].
	
	Smalltalk instVarNamed: #globals put: original.
	original := nil.! !

SystemDictionary subclass: #PSSystemDictionary
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:00:32.549'!
initialize: size

	super initialize: size.
	Smalltalk globals keysAndValuesDo: [ :key :value |
		self at: key put: value].! !

!PSSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 16:38:17.817'!
organization

	^ organization ifNil: [organization := SystemOrganization deepCopy]! !

Dictionary subclass: #PSFixtures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

PSFixtures class
	instanceVariableNames: 'instance'!

PSFixtures class
	instanceVariableNames: 'instance'!

!PSFixtures class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:30:19.665'!
at: key

	^ self instance at: key! !

!PSFixtures class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:30:01.619'!
at: key put: value
.
	^ self instance at: key put: value! !

!PSFixtures class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:33:35.27'!
example01

	| suppe |

	PSSystemDictionaryProxy new install.

	suppe := PSSystemDictionary new.
	PSFixtures at: #suppe put: suppe.

	PSCurrentSystemDictionary value: suppe during: [
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		].

	Smalltalk globals uninstall.
! !

!PSFixtures class methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 17:29:05.257'!
instance

	^ instance ifNil: [instance := self new]! !

TestCase subclass: #PSBasicTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSBasicTestCase methodsFor: 'testing' stamp: 'mig 8/9/2010 15:22:47.123'!
test01new

	| sut |
	sut := PSSystemDictionary new.

	self assert: sut size equals: Smalltalk globals size.
	Smalltalk globals keysAndValuesDo: [:key :value |
		self assert: value == (sut at: key)].
! !

!PSBasicTestCase methodsFor: 'testing' stamp: 'mig 8/10/2010 13:59:49.758'!
test02proxy

	| testCase sut root |
	
	sut := PSSystemDictionaryProxy new.
	root := Smalltalk globals.
	
	testCase := Smalltalk globals at: #TestCase.
	
	sut install.
	self assert: sut == Smalltalk globals.
	self assert: testCase == (Smalltalk globals at: #TestCase).
	sut uninstall.
	self assert: root == Smalltalk globals.! !

TestCase subclass: #PSProxiedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSProxiedTestCase methodsFor: 'running' stamp: 'mig 8/10/2010 15:25:22.565'!
setUp

	super setUp.
	PSSystemDictionaryProxy new install.! !

!PSProxiedTestCase methodsFor: 'running' stamp: 'mig 8/10/2010 14:00:41.469'!
tearDown

	Smalltalk globals uninstall.
	super tearDown.
! !

!PSProxiedTestCase methodsFor: 'testing' stamp: 'mig 8/10/2010 14:36:28.592'!
test01environment

	| newDictionary |
	newDictionary := PSSystemDictionary new.
	
	PSCurrentSystemDictionary value: newDictionary during: [
		self assert: Object environment yourself == newDictionary].
	self deny: Object environment yourself == newDictionary.
! !

!PSProxiedTestCase methodsFor: 'testing' stamp: 'mig 8/10/2010 15:25:52.941'!
test02newClasses

	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
	
	PSCurrentSystemDictionary value: PSSystemDictionary new during: [
		"Create a class and a subclass of it."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		(Smalltalk at: #PSFoobar)
			subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self assert: (Smalltalk includesKey: #PSFoobar).
		self assert: (Smalltalk includesKey: #PSFoobar2)].
	
	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
! !

!PSProxiedTestCase methodsFor: 'testing' stamp: 'mig 8/10/2010 15:20:24.867'!
test03evaluate

	self deny: (Smalltalk includesKey: #PSFoobar).
	
	PSCurrentSystemDictionary value: PSSystemDictionary new during: [
		"Create a class and instantiate it once."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		Compiler evaluate: 'PSFoobar new'].
! !

DynamicVariable subclass: #PSCurrentSystemDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!Class methodsFor: '*polysource-core-override' stamp: 'mig 8/9/2010 16:23:00.596'!
environment

	^ Smalltalk globals
	"environment == nil ifTrue: [^ super environment].
	^ environment"! !
